-- auto select python2 or python3 at executing *.py
--
local python3_exe , python2_exe

local function exec(argv)
    for i=1,#argv do
        if string.match(argv[i],' ') then
            argv[i] = '\034'..argv[i]..'\034'
        end
    end
    local cmdline = table.concat(argv,' ')
    -- print(cmdline)
    return nyaos.exec( cmdline )
end

local function python_main(...)
    local argv={...}
    if not argv[1] then
        print("python2/3 auto selector")
        print("  found python interpretor:")
        print("    python2: ".. python2_exe)
        print("    python3: ".. python3_exe)
        return
    end
    local fd=io.open(argv[1],'r')
    if not fd then
        print(argv[1]..': No such file or directory')
        return
    end
    local shebang = string.lower(fd:read())
    fd:close()
    if shebang:match('python3') then
        table.insert(argv,1,python3_exe)
    else
        table.insert(argv,1,python2_exe)
    end
    return exec(argv)
end

function nyaos.command.python(...)
    local argv={...}
    for dir in string.gmatch(os.getenv("PATH"),"[^;]+") do
        local dir_ = string.lower(dir)
        if string.match(dir_,"python3") and 
            nyaos.access(dir.."\\python.exe") 
        then
            python3_exe = dir.."\\python.exe"
            -- print("Found Python3:",python3_exe)
        elseif string.match(dir_,"python2")
            and nyaos.access(dir.."\\python.exe")
        then
            python2_exe = dir.."\\python.exe"
            -- print("Found Python2:",python2_exe)
        end
    end
    if python2_exe and python3_exe then
        nyaos.command.python = python_main
        return python_main(table.unpack(argv))
    else
        nyaos.command.python = nil
        if not string.match(argv[1],"^python(%.exe)?") then
            table.insert(argv,1,"python")
        end
        return exec( argv )
    end
end
nyaos.suffix.py = "python"
